#
# ocs initscripts, include:initscripts, initscripts-rename-device, initscripts-service, network-scripts, netconsole-service, readonly-root 
#

Summary:          Basic support for legacy System V init scripts
Name:             initscripts
Version:          10.19
Release:          2%{?dist}
License:          GPL-2.0-only
URL:              https://github.com/fedora-sysv/initscripts
Source0:          https://github.com/fedora-sysv/initscripts/archive/%{version}.tar.gz

Requires:         bash filesystem >= 3 coreutils gawk findutils grep procps-ng setup systemd util-linux chkconfig initscripts-service initscripts-rename-device
Requires(pre):    shadow-utils
Requires(post):   coreutils
BuildRequires:    filesystem >= 3 gettext glib2-devel popt-devel
BuildRequires:    gcc make git setup pkgconfig
%{?systemd_requires}
BuildRequires:    systemd
Obsoletes:        %{name}            < 10.16-1

%description
This package provides basic support for legacy System V init scripts, and some
other legacy tools & utilities.

%package -n initscripts-rename-device
Summary:          Udev helper utility that provides network interface naming

%description -n initscripts-rename-device
Udev helper utility that provides network interface naming

%package -n initscripts-service
Summary:          Support for service command
BuildArch:        noarch
Requires:         systemd
Provides:         /sbin/service

%description -n initscripts-service
This package provides service command.

%package -n network-scripts
Summary:          Legacy scripts for manipulating of network devices
Requires:         %{name}%{?_isa} = %{version}-%{release}
Requires:         bc dbus dbus-tools gawk grep hostname iproute ipcalc kmod procps-ng sed systemd
Requires(post):   chkconfig
Requires(preun):  chkconfig
Requires(post):   %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives
Obsoletes:        %{name} < 9.82-2
Provides:         deprecated()

%description -n network-scripts
This package contains the legacy scripts for activating & deactivating of most
network interfaces. It also provides a legacy version of 'network' service.

The 'network' service is enabled by default after installation of this package,
and if the network-scripts are installed alongside NetworkManager, then the
ifup/ifdown commands from network-scripts take precedence over the ones provided
by NetworkManager.

If user has both network-scripts & NetworkManager installed, and wishes to
use ifup/ifdown from NetworkManager primarily, then they has to run command:
 $ update-alternatives --config ifup

Please note that running the command above will also disable network-scriptse the 'network' service.

%package -n netconsole-service
Summary:          Service for initializing of network console logging
Requires:         %{name} = %{version}-%{release}
BuildArch:        noarch
Requires:         glibc-common iproute iputils kmod sed util-linux
Obsoletes:        %{name} < 9.82-2

%description -n netconsole-service
This packages provides a 'netconsole' service for loading of netconsole kernel
module with the configured parameters. The netconsole kernel module itself then
allows logging of kernel messages over the network.This packages provides a 'netconsole' service for loading of netconsole kernel
module with the configured parameters. The netconsole kernel module itself then
allows logging of kernel messages over the network.

%package -n readonly-root
Summary:          Service for configuring read-only root support
Requires:         %{name} = %{version}-%{release}
BuildArch:        noarch
Requires:         cpio findutils hostname iproute ipcalc util-linux
Obsoletes:        %{name}            < 9.82-2

%description -n readonly-root
This package provides script & configuration file for setting up read-only root
support. Additional configuration is required after installation.

Please note that readonly-root package is considered deprecated with limited support.
Please use systemd-volatile-root functionality instead, if possible.

%prep
%autosetup -S git

%build
%make_build PYTHON=%{__python3}

%install
%make_install

%find_lang %{name}

install -m 0755 -d %{buildroot}%{_docdir}/network-scripts

ln -s  %{_docdir}/%{name}/sysconfig.txt %{buildroot}%{_docdir}/network-scripts/
ln -sr %{_mandir}/man8/ifup.8           %{buildroot}%{_mandir}/man8/ifdown.8

touch %{buildroot}%{_sbindir}/ifup
touch %{buildroot}%{_sbindir}/ifdown

%post
%systemd_post import-state.service loadmodules.service

%preun
%systemd_preun import-state.service loadmodules.service

%postun
%systemd_postun import-state.service loadmodules.service

%post -n network-scripts
chkconfig --add network > /dev/null 2>&1 || :

[ -L %{_sbindir}/ifup ]   || rm -f %{_sbindir}/ifup
[ -L %{_sbindir}/ifdown ] || rm -f %{_sbindir}/ifdown

%{_sbindir}/update-alternatives --install %{_sbindir}/ifup   ifup   %{_sysconfdir}/sysconfig/network-scripts/ifup 90 \
                                --slave   %{_sbindir}/ifdown ifdown %{_sysconfdir}/sysconfig/network-scripts/ifdown \
                                --initscript network

%preun -n network-scripts
if [ $1 -eq 0 ]; then
  chkconfig --del network > /dev/null 2>&1 || :
  %{_sbindir}/update-alternatives --remove ifup %{_sysconfdir}/sysconfig/network-scripts/ifup
fi

%post -n netconsole-service
%systemd_post netconsole.service

%preun -n netconsole-service
%systemd_preun netconsole.service

%postun -n netconsole-service
%systemd_postun netconsole.service

%post -n readonly-root
%systemd_post readonly-root.service

%preun -n readonly-root
%systemd_preun readonly-root.service

%postun -n readonly-root
%systemd_postun readonly-root.service

%files -f %{name}.lang
%license COPYING
%doc doc/sysconfig.txt

%dir %{_sysconfdir}/rc.d
%dir %{_sysconfdir}/rc.d/init.d
%dir %{_sysconfdir}/rc.d/rc[0-6].d
%dir %{_sysconfdir}/sysconfig/console
%dir %{_sysconfdir}/sysconfig/modules
%dir %{_libexecdir}/%{name}
%dir %{_libexecdir}/%{name}/legacy-actions

%{_sysconfdir}/rc.d/init.d/functions
%{_sysconfdir}/rc[0-6].d
%{_sysconfdir}/init.d
%{_bindir}/*
%{_sbindir}/consoletype
%{_sbindir}/genhostid
%{_libexecdir}/import-state
%{_libexecdir}/loadmodules
%{_prefix}/lib/systemd/system/import-state.service
%{_prefix}/lib/systemd/system/loadmodules.service
%{_mandir}/man1/*

%files -n initscripts-rename-device
%{_prefix}/lib/udev/rename_device
%{_udevrulesdir}/*

%files -n initscripts-service
%dir %{_libexecdir}/%{name}
%dir %{_libexecdir}/%{name}/legacy-actions
%{_sbindir}/service
%{_mandir}/man8/service.*

%files -n network-scripts
%doc doc/examples/
%dir %{_sysconfdir}/sysconfig/network-scripts
%{_sysconfdir}/rc.d/init.d/network
%{_sysconfdir}/sysconfig/network-scripts/*
%config(noreplace)    %{_sysconfdir}/sysconfig/network-scripts/ifcfg-lo
%ghost                %{_sbindir}/ifup
%ghost                %{_sbindir}/ifdown
%attr(4755,root,root) %{_sbindir}/usernetctl
%{_mandir}/man8/ifup.*
%{_mandir}/man8/ifdown.*
%{_mandir}/man8/usernetctl.*
%{_docdir}/network-scripts/*

%files -n netconsole-service
%config(noreplace) %{_sysconfdir}/sysconfig/netconsole
%{_libexecdir}/netconsole
%{_prefix}/lib/systemd/system/netconsole.service

%files -n readonly-root
%dir %{_sharedstatedir}/stateless
%dir %{_sharedstatedir}/stateless/state
%dir %{_sharedstatedir}/stateless/writable
%config(noreplace) %{_sysconfdir}/rwtab
%config(noreplace) %{_sysconfdir}/statetab
%config(noreplace) %{_sysconfdir}/sysconfig/readonly-root
%{_libexecdir}/readonly-root
%{_prefix}/lib/systemd/system/readonly-root.service

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.19-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Aug 21 2023 Wang Guodong <gordonwwang@tencent.com> - 10.19-1
- Upgrade to version 10.19

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.16-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.16-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Apr 19 2022 Zhongze Hu <joshuahu@tencent.com> - 10.16-1
- init build
